CocktailSearch = new Class({

  api: 'http://api.mixable.de',
  web: 'http://www.mixable.de',
  p: 1, l: 0, t: 0,
  sLastQ: '', sLastI: '', sLastU: '', sLastO: '',
  request: null,
  fade: 'in',
  minH: 174,

  initialize:function() {
    var gDoneButton = new AppleGlassButton($('doneButton'), 'Done', this.hidePrefs.bind(this)); 
    var gInfoButton = new AppleInfoButton($('infoButton'), $('front'), 'white', 'white', this.showPrefs.bind(this));
		
    this.gResultScrollArea = new AppleScrollArea($('result'));
    this.gResultScrollbar = new AppleVerticalScrollbar($('resultScrollbar'));
    this.gResultScrollArea.addScrollbar(this.gResultScrollbar);
    this.gResultScrollbar.setAutohide(true);
    this.gDetailScrollArea = new AppleScrollArea($('detailFrame'));
    this.gDetailScrollbar = new AppleVerticalScrollbar($('detailScrollbar'));
    this.gDetailScrollArea.addScrollbar(this.gDetailScrollbar);
    this.gDetailScrollbar.setAutohide(true);
    
    this.fxSearchArea = new Fx.Style('searchArea', 'opacity', { wait:false, duration:250, transition: Fx.Transitions.Quad.easeOut }).set(1);
    this.fxDetailArea = new Fx.Style('detailArea', 'opacity', { wait:false, duration:250, transition: Fx.Transitions.Quad.easeOut }).set(0);
    this.fxDetailExtra = new Fx.Style('detailExtra', 'right', { wait:false, duration:250, transition: Fx.Transitions.Quad.easeOut });

    this.dataIndex = '<div align="center" id="index"><img src="Images/t_search.png"></div>';
    $('resultInfo').setHTML(this.dataIndex);
    var sett = '';
    sett += '<table><tr>';
    sett += '<td colspan="3">' + this.getLocString('Search for') + '<br /><select name="searchIn" id="searchIn"><option value="">' + this.getLocString('names and ingredients') + '</option><option value="name">' + this.getLocString('recipe names') + '</option><option value="ingredient">' + this.getLocString('ingredients') + '</option></select></td>';
    sett += '</tr><tr>';
    sett += '<td>' + this.getLocString('Order results by') + '<br /><select name="order" id="order"><option value="rating">' + this.getLocString('ratings') + '</option><option value="name">' + this.getLocString('recipe names') + '</option></select></td>';
    sett += '<td style="width:12px;"></td>';
    sett += '<td>' + this.getLocString('Preferred unit') + '<br /><select name="unit" id="unit"><option value="">' + this.getLocString('none') + '</option><option value="cl">' + this.getLocString('cl (centilitre)') + '</option><option value="ml">' + this.getLocString('ml (millilitre)') + '</option><option value="oz">' + this.getLocString('oz (fluid ounce, USA)') + '</option></select></td>';
    sett += '</tr></table>';
    sett += '<input type="checkbox" id="autoCheck" />&nbsp;' + this.getLocString('Automatically check for updates.');
    $('settings').setHTML(sett);
    $('version').setHTML('CocktailSearch v' + this.getKeyValue('CFBundleShortVersionString'));
    $('detailInfo').setHTML('<div class="link">' + this.getLocString('More detailed infos &#187;') + '</div>');

    $('q').addEvents({
      keyup:function() { this.startSearch(); }.bind(this),
      change:function() { this.startSearch(); }.bind(this),
      click:function() { this.startSearch(); }.bind(this) // Search-Reset-Click
    });
    
    $$('#detailName, #backToSearch, #detailFrame').addEvent('click', this.hideDetail.bind(this));
    $('openWebsite').addEvent('click', function() {
      this.openUrl(this.web + '/');
    }.bind(this));
    
    this.fxPrev = new Fx.Style('prev', 'opacity', { wait:false, duration:400, transition: Fx.Transitions.Quad.easeOut }).set(0);
    this.fxNext = new Fx.Style('next', 'opacity', { wait:false, duration:400, transition: Fx.Transitions.Quad.easeOut }).set(0);

    $('prev').addEvents({
      mouseover:function() { this.fxPrev.start(1); }.bind(this),
      mouseout:function() { $('prev').getStyle('opacity') > 0.4 ? this.fxPrev.start(0.4) : null; }.bind(this),
      click:function() {
        if (!this.request.running && this.p > 1) {
          this.p--;
          this.getSearchResults();
        }
      }.bind(this)
    });
    $('next').addEvents({
      mouseover:function() { this.fxNext.start(1); }.bind(this),
      mouseout:function() { $('next').getStyle('opacity') > 0.4 ? this.fxNext.start(0.4) : null; }.bind(this),
      click:function() {
        if (!this.request.running && this.p*this.l < this.t) {
          this.p++;
          this.getSearchResults();
        }
      }.bind(this)
    });

    this.oldH = 0;
		this.resize = new Drag.Base('front', {
			limit: {y: [this.minH+3, this.minH+200]},
			modifiers: {x: false, y: 'height'},
			handle:$('resize'),
			snap:0,
			onDrag:function() {
				var h = this.resize.value.now['y'] - this.minH;
		    $('mid').setStyle('height', h);
		    this.refreshView();
		    if (window.widget) window.resizeTo(window.innerWidth, h + this.minH);
			}.bind(this)
		});
    
    var refreshFunc = function() { this.refreshView(); }.bind(this);

    this.fxResizeUp = new Fx.Elements($$('#front, #mid'), { duration:400, transition:Fx.Transitions.Quint.easeOut,
      onStart:function() {
        this.timer = $clear(this.timer);
        this.timer = refreshFunc.periodical(Math.round(1000/this.fxResizeUp.options.fps), this);
      }.bind(this),
      onComplete:function() {
        this.timer = $clear(this.timer);
        if (window.widget) window.resizeTo(window.innerWidth, this.minH+3);
      }.bind(this),
      onCancel:function() {
        this.timer = $clear(this.timer);
      }.bind(this)
    });
    this.fxResizeDown = new Fx.Elements($$('#front, #mid'), { duration:800, transition:Fx.Transitions.Bounce.easeOut,
      onStart:function() {
        this.timer = $clear(this.timer);
        this.timer = refreshFunc.periodical(Math.round(1000/this.fxResizeDown.options.fps), this);
      }.bind(this),
      onComplete:function() {
        this.timer = $clear(this.timer);
      }.bind(this),
      onCancel:function() {
        this.timer = $clear(this.timer);
      }.bind(this)
    });

	  if (window.widget) {
	    widget.onshow = this.onshow.bind(this);
	  }

    this.fxUpdate = new Fx.Style('update', 'opacity', { wait:false, duration:400, transition: Fx.Transitions.Quad.easeOut }).set(0);
		$('update').setStyle('display', 'block');
		$('updateClose').addEvent('click', function() {
			this.fxUpdate.start(0);
		}.bind(this));
		$('updateNow').addEvent('click', function() {
	    this.openUrl(this.web + this.getLocString('/') + 'downloads/view/cocktailsearch-mac');
		}.bind(this));
  },
  
  onshow:function() {
    if (window.widget) {
      var lastCheck = widget.preferenceForKey("lastCheck");
      var date = new Date();
      var diff = Math.round((date.getTime() - (lastCheck || 0)) / 1000);
      if (diff > (14*60*60*24) && (widget.preferenceForKey('autoCheck') !== undefined ? widget.preferenceForKey('autoCheck') : true)) {
        this.checkForUpdates();
        widget.setPreferenceForKey(date.getTime(),"lastCheck");
      }
    }
  },
  
  refreshView:function() {
    var resultH = 32 + $('result').getCoordinates()['height']/2;
    $('resultInfo').setStyle('top', resultH - 12);
    $('dLoader').setStyle('top', resultH + 5);

    this.gResultScrollArea.refresh();
    this.gResultScrollbar.refresh();
    this.gDetailScrollArea.refresh();
    this.gDetailScrollbar.refresh();

		if (this.lastDetailScrollbarStatus != this.gDetailScrollbar.hidden) {
			if (this.gDetailScrollbar.hidden) {
				this.fxDetailExtra.start(10);
			}
			else {
				this.fxDetailExtra.start(28);
			}
		}
		this.lastDetailScrollbarStatus = this.gDetailScrollbar.hidden;
  },
  
  showDetail:function(id) {
    $('detailName').setHTML(this.dataJson['search'][id]['name']);
    var r = '';
    for(var i = 0; i < 5; i++) {
      r += '<img src="Images/rating' + (i < this.dataJson['search'][id]['rating'] ? '1' : '0') + '.png" />';
    }
    $('detailRating').setHTML(r);
    $('detail').setHTML(this.dataJson['search'][id]['ingreds']);
		if (this.dataJson['search'][id]['alc'] >= 0) {
    	$('detailAlc').setHTML(this.dataJson['search'][id]['alc'] + ' %<br /><small>Vol.</small>');
		}
		else {
    	$('detailAlc').setHTML('');
		}
    $('detailInfo').removeEvents();
    $('detailInfo').addEvent('click', function() {
      this.openUrl(this.web + this.getLocString('/') + 'recipes/view/' + this.dataJson['search'][id]['nice']);
    }.bind(this));

    this.fade = 'out';
    this.refreshView();
    this.fxSearchArea.start(0).chain(function() {
      if (this.fade == 'out') {
        this.fxDetailArea.start(1);
      }
    }.bind(this));
  },
  hideDetail:function() {
    this.fade = 'in';
    this.fxDetailArea.start(0).chain(function() {
      if (this.fade == 'in') {
        this.fxSearchArea.start(1);
      }
    }.bind(this));
  },
  showPrefs:function() {
    if (window.widget) {
      $('searchIn').value = (widget.preferenceForKey('searchIn') ? widget.preferenceForKey('searchIn') : '');
      $('autoCheck').checked = (widget.preferenceForKey('autoCheck') !== undefined ? widget.preferenceForKey('autoCheck') : true);
    }
		this.resizeToMin().chain(function() {
      if (window.widget) widget.prepareForTransition('ToBack'); 
      $('front').setStyle('display', 'none'); 
      $('back').setStyle('display', 'block'); 
      if (window.widget) setTimeout('widget.performTransition();', 0); 
    });
  },
  hidePrefs:function() {
    if (window.widget) widget.prepareForTransition('ToFront'); 
    $('back').setStyle('display', 'none'); 
    $('front').setStyle('display', 'block'); 
    if (window.widget) setTimeout('widget.performTransition();', 0);

    if (window.widget) {
      widget.setPreferenceForKey($('searchIn').value, 'searchIn');
      widget.setPreferenceForKey($('autoCheck').checked, 'autoCheck');
    }
    this.resizeToMax();
    this.startSearch();
    this.refreshView();
  },
  
  startSearch:function() {
		var qValue = $('q').value.replace(/^\s*([^\s]*)\s*$/, '$1'); // trim
		
    if (qValue != this.sLastQ || $('searchIn').value != this.sLastI || $('order').value != this.sLastO || $('unit').value != this.sLastU) {
  		$clear(this.qTimer);
      if (this.request) this.request.cancel();

      if (qValue.length <= 1) {
        $('resultInfo').setHTML(this.dataIndex);
        $('result').setHTML('');
        this.refreshView();
        $('searchInfo').setHTML('');
        $('dLoader').setStyle('visibility', 'hidden');
        this.fxPrev.start(0);
        this.fxNext.start(0);
      }
      else {
    		this.qTimer = function() {
    		  this.p = 1;
    		  this.getSearchResults();
    		}.delay(500, this);
      }
    }
    this.sLastI = $('searchIn').value;
    this.sLastU = $('unit').value;
    this.sLastO = $('order').value;
    this.sLastQ = qValue;
  },
  getSearchResults:function() {
    $('dLoader').setStyle('visibility', 'visible');
    if (this.request) {
      this.request.cancel();
    }
  	this.request = new XHR({
  	  method: 'get',
//	  	headers: {'X-Client-Version': this.getKeyValue('CFBundleVersion') + 'mac'},
  	  onSuccess:function() {
        $('dLoader').setStyle('visibility', 'hidden');
        this.handleSearchResult(this.request.response.text);
      }.bind(this),
  	  onFailure:function() {
        $('dLoader').setStyle('visibility', 'hidden');
        this.showError('Could not connect to server.');
  	  }.bind(this)
  	}).send(this.api + this.getLocString('/') + 'search?q=' + encodeURIComponent($('q').value) + '&in=' + $('searchIn').value + '&p=' + this.p + '&u=' + $('unit').value + '&o=' + $('order').value);
  },
  handleSearchResult:function(xml) {
    this.dataJson = Json.evaluate(xml);
    
    $('searchInfo').setHTML('');
    $('resultInfo').setHTML('');
    $('result').setHTML('');
    this.refreshView();
    try {
      var result = '';
      var i = 0;
    	$each(this.dataJson['search'], function(data, value){
      	if (data['name'] != '') {
          result += '<div class="row' + (i%2 ? '1' : '2') + ' link" onclick="Widget.showDetail(\'' + i + '\')">';
        	result += '<b>' + data['name'] + '</b> ';
        	result += (data['group'] != '' ? '<small>(' + data['group'] + ')</small>' : '') + '<br>';
        	result += '<span class="grey">' + data['detail'] + '</span>';
          result += '</div>';
      	}
      	i++;
      });
      $('result').setHTML(result);
      
      var f = (this.dataJson['p']-1)*this.dataJson['l']+1;
      var l = (this.dataJson['p']*this.dataJson['l'] > this.dataJson['t'] ? this.dataJson['t'] : this.dataJson['p']*this.dataJson['l']);
      $('searchInfo').setHTML(f + ' - ' + l + this.getLocString(' of ') + this.dataJson['t'] + this.getLocString(' recipes.'));
      
      this.p = this.dataJson['p'];
      this.l = this.dataJson['l'];
      this.t = this.dataJson['t'];

      if (this.dataJson['p'] > 1) { if ($('prev').getStyle('opacity') < 0.4) this.fxPrev.start(0.4); }
      else { this.fxPrev.start(0); }
      if (this.dataJson['p']*this.dataJson['l'] < this.dataJson['t']) { if ($('next').getStyle('opacity') < 0.4) this.fxNext.start(0.4); }
      else { this.fxNext.start(0); }
      
      if (i == 0){
      	if (this.dataJson['alt']) {
      	  $('resultInfo').setHTML('<div class="userinfo link" onclick="$(\'q\').value=\'' + this.dataJson['alt'] + '\'; Widget.getSearchResults();">' + this.getLocString('Did you mean ') + '&quot;<u>' + this.dataJson['alt'] + '</u>&quot;?</div>');
      	}
      	else {
      	  $('resultInfo').setHTML('<div class="userinfo grey">' + this.getLocString('No recipes found.') + '</div>');
      	}
    	  $('result').setHTML('');
      	$('searchInfo').setHTML('');
      }
    } catch (ex) {
      this.showError(this.getLocString('Error reading recipe data.'));
    }
    this.refreshView();
  },

  resizeToMin:function() {
    this.oldH = $('front').getStyle('height').toInt();
    return this.fxResizeUp.start({
      '0':{'height':this.minH+3},
      '1':{'height':3}
    });
  },
  resizeToMax:function() {
    var down = function() {
      if (window.widget) window.resizeTo(window.innerWidth, this.oldH);
      this.fxResizeDown.start({
        '0':{'height':this.oldH},
        '1':{'height':this.oldH-this.minH}
      });
    }.bind(this);
    down.delay(800, this);
  },
  
  checkForUpdates:function() {
  	this.vCheck = new XHR({
  	  method: 'get',
  	  onSuccess:function() {
        var lVersion = Json.evaluate(this.vCheck.response.text);
        var tVersion = this.getKeyValue('CFBundleVersion');
        if (lVersion['version'].toFloat() > tVersion.toFloat()) {
					this.fxUpdate.start(1);
        }
  	  }.bind(this)
  	}).send(this.api + this.getLocString('/') + 'downloads/latest?dl=cocktailsearch-mac');
  },

  getLocString:function(key) {
    try {
      var str = locStrings[key];
      if (str === undefined) 
        str = key;
      return str;
    } catch (ex) {}
    return key;
  },
  getKeyValue:function(key) {
    req = new XMLHttpRequest();
    req.open("GET", "Info.plist", false);
    req.send(null); 

    var xml = req.responseXML;
    var key_value = null;
    var nodes = xml.getElementsByTagName("dict")[0].childNodes; 

    for (var i=0; i < nodes.length; i++) {
      if (nodes[i].nodeType == 1 && nodes[i].tagName.toLowerCase() == "key" && nodes[i].firstChild.data == key) {
        if (nodes[i+2].tagName.toLowerCase() != "array")
          key_value = nodes[i+2].firstChild.data;
        else {
          key_value = new Array();
          var ar_nodes = nodes[i+2].childNodes;
          for (var j=0; j < ar_nodes.length; j++) {
            if (ar_nodes[j].nodeType == 1) key_value.push(ar_nodes[j].firstChild.data);
          }
        } 
        break;
      }
    } 
    return key_value;
  },

  showError:function(key) {
    $('searchInfo').setHTML(this.getLocString(key));
  },
  openUrl:function(url) {
    if (window.widget) widget.openURL(url);
	}
});

var Widget = null;

window.addEvent('domready', function() {
	Widget = new CocktailSearch();
});